/* 
 *    XSitecopy, for managing remote web sites with a GNOME interface.
 *    Copyright (C) 1999, Lee Mallabone <lee0@callnetuk.com
 *                                                                      
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *   
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *   
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include <stdio.h>
#include <gnome.h>
#include "sites.h"
#include "rcfile.h"
#include "common.h"
#include "fe_gnome_common.h"
#include "fe_gnome_creation.h"
#include "fe_gtk_main.h" /* deprecated? */

/* The main gnome_app struct */
GtkWidget *sitecopy;

extern struct site_t *all_sites;

gchar *current_name;
bool prompting = false;

/* Pixmaps that are used throughout. */

GdkPixmap *closed_dir, *open_dir;
GdkPixmap *red_file, *green_file, *orange_file;
GdkBitmap *dir1_map, *dir2_map;
GdkBitmap *red_file_map, *green_file_map, *orange_file_map;

int generate_pixmaps (void) {
   GtkStyle *style;
   
   style = gtk_widget_get_style (sitecopy);
   closed_dir = gdk_pixmap_create_from_xpm (sitecopy->window,
					    &dir1_map,
					    &style->bg[GTK_STATE_NORMAL],
					    "Directory.xpm");
   open_dir = gdk_pixmap_create_from_xpm (sitecopy->window,
					  &dir2_map,
					  &style->bg[GTK_STATE_NORMAL],
					  "Directory2.xpm");
   green_file = gdk_pixmap_create_from_xpm (sitecopy->window,
					    &green_file_map,
					    &style->bg[GTK_STATE_NORMAL],
					    "green_file.xpm");
   orange_file = gdk_pixmap_create_from_xpm (sitecopy->window,
					    &orange_file_map,
					    &style->bg[GTK_STATE_NORMAL],
					    "orange_file.xpm");
   red_file = gdk_pixmap_create_from_xpm (sitecopy->window,
					  &red_file_map,
					  &style->bg[GTK_STATE_NORMAL],
					  "red_file.xpm");
   return 1;
}

int
main (int argc, char *argv[]) {

   gnome_init ("Sitecopy", VERSION, argc, argv);

   /* Configuration / Gnome initialisation */
   
   fe_gnome_init ();
   sitecopy = gnome_app_new ("xsc", "XSitecopy");
   gtk_widget_realize (sitecopy);
   generate_pixmaps ();

   /* Blurb that is probably deprecated */
   current_name = malloc (BUFSIZ);
   strcpy (current_name, "none");
   
   /* Create the GUI and hit the main loop */
   create_main_window();   

   gtk_main ();
   return 1;
}
 
