/* 
 *      XSitecopy, for managing remote web sites with a GNOME interface.
 *      Copyright (C) 1999, Lee Mallabone <lee0@callnetuk.com
 *                                                                        
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *     
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *     
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 */
#include "fe_gtk_main.h"
#include "fe_gnome_common.h"

extern struct site_t *all_sites;
extern GtkWidget *status_bar;

GtkWidget *excludes_clist, *excludes_entry;
extern struct site_t *selected_site;

int exclude_row = -1;

void populate_excludes (void) {
   int i;
   gchar *to_add[1];
   
   for (i=0; i < selected_site->numexcludes; i++) {
      to_add[0] = selected_site->excludes[i];
      exclude_row = gtk_clist_append (GTK_CLIST (excludes_clist), to_add);
   }
}

void select_exclude (GtkWidget *list, gint row) {
   gchar *to_change;
   exclude_row = row;

   gtk_clist_get_text (GTK_CLIST (excludes_clist), row, 0, &to_change);
   gtk_entry_set_text (GTK_ENTRY (excludes_entry), to_change);
}

/* Should probably be in fe_gtk_changes.c but what the hell */

void change_exclude (GtkWidget *entry, gpointer data) {
   gchar *text;
   extern bool rcfile_saved;
   
   text = gtk_entry_get_text (GTK_ENTRY (excludes_entry));
   gtk_clist_set_text (GTK_CLIST (excludes_clist), exclude_row, 0, text);
   selected_site->excludes[exclude_row] = (char *) strdup(text);
   rcfile_saved = false;
}

void add_exclude (GtkWidget *button, gpointer data) {
   int added_row;
   gchar *to_add[1];
   
   to_add[0] = "New exclude expression";
   added_row = gtk_clist_append (GTK_CLIST (excludes_clist), to_add);
   selected_site->numexcludes++;
   selected_site->excludes[selected_site->numexcludes] = to_add[0];
   gtk_clist_select_row (GTK_CLIST (excludes_clist), added_row, 0);
}

void remove_exclude (GtkWidget *button, gpointer data) {
   int i, j;
   gtk_clist_remove (GTK_CLIST (excludes_clist), exclude_row);
   for (i=exclude_row; i < selected_site->numexcludes; i++) {
      j = i + 1;
      selected_site->excludes[i] = selected_site->excludes[j];
   }
   selected_site->numexcludes--;
}

