/* 
 *      XSitecopy, for managing remote web sites with a GNOME interface.
 *      Copyright (C) 1999, Lee Mallabone <lee0@callnetuk.com>
 *                                                                        
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *     
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *     
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 */

/* This is biggggggggggg on externs and stuff... Not all that sure that they
 * can be weened down either.. :\
 */

#include "config.h"
#include "rcfile.h"
#include <gnome.h>
#include "protocol.h"
#include "fe_gtk_main.h"
#include "fe_gnome_common.h"
#include "fe_gtk_changes.h"
#include "fe_gtk_excludes.h"
#include "fe_gtk_site_widgets.h"
#include "fe_gtk_file_widgets.h"
#include "fe_gtk_site_ops.h"

int generate_pixmaps (void);
extern struct site_t *all_sites;
extern GtkWidget *site_tree, *status_bar;

bool rcfile_saved = true;

extern char *copypath;

/* Global widgets */
extern GtkWidget *main_area_box, *area_data;
extern GtkWidget *the_tree;
GtkWidget *error_log_list, *error_log_window;

/* External widgets */
extern GtkWidget *excludes_clist, *excludes_entry;
extern GtkWidget *name_map_clist, *name_map_local_entry, *name_map_remote_entry;
extern GtkWidget *main_app_window;

/* External icons */
extern GdkPixmap *closed_dir, *open_dir;
extern GdkPixmap *red_file, *green_file, *orange_file;
extern GdkBitmap *dir1_map, *dir2_map;
extern GdkBitmap *red_file_map, *green_file_map, *orange_file_map;

struct site_info *area_contents_s;

struct site_t *selected_site;
GtkCTreeNode *current_site_node;
GtkCTreeNode *site_item, *file_item;

/* Name of current ctree selection */
/* Deprecate this! */
gchar *name;
extern int exclude_row;
extern struct proto_driver ftp_driver;
#ifdef USE_DAV
extern struct proto_driver dav_driver;
#endif

GtkWidget *sitename_entry, *localpath_entry, *remotepath_entry;

/******************************************/

void actually_quit (gint button_number) {
   if (button_number == GNOME_YES) {
      gtk_main_quit();
   }
   return;
}

void quit_question (void) {
   fe_gtk_question ("Are you sure you want to quit?", (GnomeReplyCallback) (actually_quit));
}

void quit_save (gint button_number) {
   if (button_number == GNOME_YES) {
      save_default();
   }
   quit_question();
}

void quit_please (gint button_number) {
   if (! rcfile_saved) {
     fe_gtk_question ("Your site definitions are not saved. Do you wish to save before exiting?",
		      (GnomeReplyCallback) (quit_save));
   } else {
      quit_question();
   }
}

gint exit_handler (GtkWidget *widget, GdkEvent *event, gpointer data) {
   return (TRUE);
}

int make_defaults (struct site_t *a_site) {

   a_site->server = (char *) malloc (BUFSIZ);
   strcpy (a_site->server, "new_server_name");
   a_site->username = (char *) malloc (BUFSIZ);
   strcpy (a_site->username, "your_username");
   a_site->password = (char *) malloc (BUFSIZ);
   strcpy (a_site->password, "password");
   a_site->url = (char *) malloc (BUFSIZ);
   strcpy (a_site->url, "http://localhost");
   a_site->nodelete = false;
   a_site->checkmoved = false;
   a_site->ftp_pasv_mode = true;
   a_site->files = NULL;
   a_site->renames = NULL;
   a_site->numexcludes = 0;
   a_site->protocol = siteproto_ftp;
   a_site->port = 0;
   a_site->perms = sitep_ignore;
   a_site->symlinks = sitesym_follow;
   a_site->driver = &ftp_driver;
   a_site->infofile = malloc (BUFSIZ);
   strcpy (a_site->infofile, copypath);
   return 1;
}

int add_site (void) {
   int ret;
   struct site_t *site_to_add;
   GtkCTreeNode *site_im_adding;
   gchar *name, *path, *remotepath, tmp[BUFSIZ], *node_label[1];
   struct ctree_attachment *extra_info;
   
   name = (gchar *) malloc (BUFSIZ);
   path = (gchar *) malloc (BUFSIZ);
   remotepath = (gchar *) malloc (BUFSIZ);
   name = gtk_entry_get_text (GTK_ENTRY (sitename_entry));
   
   if (name == NULL) {
      fe_status ("You must supply a name for the site.");
      return 0;
   }
   path = gnome_file_entry_get_full_path (GNOME_FILE_ENTRY (localpath_entry), 1);
   if (path == NULL) {
      fe_status ("You must provide a local path for the site.");
      return 0;
   }
   
   remotepath = gtk_entry_get_text (GTK_ENTRY (remotepath_entry));
   if (remotepath == NULL) {
      fe_status ("You must provide a remote directory for the site.");
      return 0;
   }
/*   printf ("Will add %s to sitelist with local path %s and remote %s.\n", 
	   name, path, remotepath);*/
   
   /* Create a site with the correct defaults */
   site_to_add = malloc (sizeof (struct site_t));
   site_to_add->name = (char *) strdup (name);
   site_to_add->local_root = (char *) strdup (path);
   site_to_add->remote_root = (char *) strdup (remotepath);
   make_defaults (site_to_add);
   strcat (site_to_add->infofile, name);
//   printf ("infofile is %s\n", site_to_add->infofile);
   
   /* We need to make sure we're not adding a pile of poo to the sites list. */
   
   ret = rc_verifysite (site_to_add);
   printf ("verify site produced code %d on the new site.\n", ret);
   switch( ret ) {
    case SITE_ACCESSLOCALDIR:
      printf( "Could not read directory for `%s':\n\t%s\n", 
	     site_to_add->name, site_to_add->local_root );
      break;
    case SITE_NOLOCALDIR:
      printf( "Local directory not specified in site `%s'.\n", 
	     site_to_add->name );
      break;
    case SITE_INVALIDPORT:
      printf( "Invalid port used in site `%s'.\n",
	     site_to_add->name );
      break;
    default:
      break;
   }
   
   /* Tag this site onto the start of the sites list */
   site_to_add->next = all_sites;
   all_sites = site_to_add;
   
   /* Add the entry to the ctree */

   sprintf (tmp, "%s  (%s)", site_to_add->name, site_to_add->local_root);
   node_label[0] = tmp;
   site_im_adding = gtk_ctree_insert_node (GTK_CTREE (the_tree), NULL, NULL, node_label,
				      0, NULL, NULL, NULL, NULL, false, false);
   site_readfiles (site_to_add);
   /* Create the file entries */
   populate_site_node (site_im_adding, site_to_add);
   gtk_ctree_sort_node (GTK_CTREE (the_tree), GTK_CTREE_NODE (site_im_adding));
   /* Add the pointer to the site */
   extra_info = malloc (sizeof (struct ctree_attachment));
   extra_info->file_or_site = IS_A_SITE;
   extra_info->info_struct = (void *) site_to_add;
//   printf ("Setting data of new row...\n");
   gtk_ctree_node_set_row_data (GTK_CTREE (the_tree), site_im_adding,
				(gpointer) extra_info);
   rcfile_saved = false;
   return 1;
}

void select_ctree_cb (GtkCTree *ctree, GtkCTreeNode *node, gpointer data) {
   GtkCTreeNode *parent;
   struct site_t *current_site;
   struct site_file_t *current_file;
   void *data_to_get;
   struct ctree_attachment *actual_data;
   
   current_site = malloc (sizeof (struct site_t));
   if (GTK_CTREE_ROW (node)->parent == NULL) {   /* We're at the top level */
      if ( (data_to_get = gtk_ctree_node_get_row_data (GTK_CTREE (ctree), GTK_CTREE_NODE (node))) == NULL) {
	 printf ("\"Data get\" returned NULL. Oh dear.\n");
      }
      actual_data = (struct ctree_attachment *) data_to_get;
      if (actual_data->file_or_site != IS_A_SITE)
	 printf ("Somehow you've clicked on a site, but ended up with file data!\n");
      current_site = (struct site_t *) actual_data->info_struct;

      /* Make the data shared */
      selected_site = current_site;
      current_site_node = node;
      
      gtk_container_remove (GTK_CONTAINER (main_area_box), area_data);
      area_data = make_site_info_area (current_site);
      gtk_container_add (GTK_CONTAINER (main_area_box), area_data);
   } else if (GTK_CTREE_ROW (node)->parent != NULL) {

      parent = GTK_CTREE_ROW (node)->parent;

      /* Grab the file data from that row */
      if ( (data_to_get = gtk_ctree_node_get_row_data (GTK_CTREE (ctree), GTK_CTREE_NODE (node))) == NULL) {
	 printf ("\"Data get\" for the file returned NULL. Oh dear.\n");
      }
      actual_data = (struct ctree_attachment *) data_to_get;
      if (actual_data->file_or_site != IS_A_FILE)
	 printf ("Somehow you've clicked on a file, but ended up with site data!\n");
      current_file = (struct site_file_t *) actual_data->info_struct;

      /* Grab the site data from the file's parent */
      while (GTK_CTREE_ROW (parent)->parent != NULL) {
	 parent = GTK_CTREE_ROW(parent)->parent;
	 printf ("Assigned parent to node->parent.\n");
      }

      if ( (data_to_get = gtk_ctree_node_get_row_data (GTK_CTREE (ctree), GTK_CTREE_NODE (parent))) == NULL) {
	 printf ("\"Data get\" for the file's parent returned NULL. Oh dear.\n");
      }
      actual_data = (struct ctree_attachment *) data_to_get;
      if (actual_data->file_or_site != IS_A_SITE)
	 printf ("Somehow you've clicked on a file, but it's parent was a file too!?\n");
      current_site = (struct site_t *) actual_data->info_struct;
      selected_site = current_site;
      current_site_node = parent;      
      if (current_file == NULL) {
	 fe_status ("Unable to access info about the selected file.");
      } else {
	 gtk_container_remove (GTK_CONTAINER (main_area_box), area_data);
	 area_data = make_file_info_area (current_file);
	 gtk_container_add (GTK_CONTAINER (main_area_box), area_data);
      }
   } else {
      g_print ("If you got to here, something is really buggered, quite frankly.\n");
   }
}

GtkWidget *create_default_main_area (void) {
   GtkWidget *vbox, *label;
   
   vbox = gtk_vbox_new (FALSE, 5);
   label = gtk_label_new ("No site is currently selected.\n\nPlease choose one from the tree view\non the left before proceeding with any more operations.");
   gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 10);
   gtk_widget_show (label);
   
   gtk_widget_show (vbox);
   return vbox;
}

GtkWidget *create_initial_main_area (void) {
   GtkWidget *vbox, *label;
   gchar summary[BUFSIZ];
   gint num_that_need_updates = 0;
   struct site_t *tmp_site;
   
   vbox = gtk_vbox_new (FALSE, 10);
   /* TODO: Add some checking to see if this is the first time they've run sitecopy,
    * change greeting accordingly. 
    */
   label = gtk_label_new ("\nWelcome to XSitecopy!\n\n");
   gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 10);
   gtk_widget_show (label);
   
   for (tmp_site = all_sites; tmp_site != NULL; tmp_site = tmp_site->next) {
      if (tmp_site->is_different) {
	 sprintf (summary, "The site '%s' requires an update.", tmp_site->name);
	 label = gtk_label_new (summary);
	 gtk_widget_show (label);
	 gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 1);
	 num_that_need_updates++;
      }
   }
   if (all_sites == NULL) {
      label = gtk_label_new ("Click on \"New site\" to begin using the program.");
      gtk_widget_show (label);
      gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);
      
   } else if (num_that_need_updates == 0) {
      label = gtk_label_new ("All local sites are fully synchronized with the remote sites.");
      gtk_widget_show (label);
      gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);
   }
   gtk_widget_show (vbox);
   return vbox;
}

void site_report (void) {
   gtk_container_remove (GTK_CONTAINER (main_area_box), area_data);
   area_data = create_initial_main_area ();
   gtk_container_add (GTK_CONTAINER (main_area_box), area_data);
}

void site_web_report (void) {
   gchar lee[BUFSIZ];
   gchar *command_to_exec;
   
   if (selected_site == NULL) {
      fe_status ("For a report to be generated, a site must be selected.");
      return;
   }
   /* FIXME: path */
   sprintf (lee, "sitecopy -ll %s | awk -f changes.awk > /tmp/xsitecopy_report.html",
	    selected_site->name);
   command_to_exec = (gchar *) malloc (strlen (lee) + 1);
   /* Using snprintf to maybe try and add just a teeny bit of security? */
   snprintf (command_to_exec, (strlen(lee) + 1), lee);
   system (command_to_exec);
   system ("gnome-moz-remote --newwin /tmp/xsitecopy_report.html");
}
   
void redraw_main_area (void) {
   gtk_container_remove (GTK_CONTAINER (main_area_box), area_data);
   area_data = make_site_info_area (selected_site);
   gtk_container_add (GTK_CONTAINER (main_area_box), area_data);
}

void clear_main_area (void) {
   selected_site = NULL;
   gtk_container_remove (GTK_CONTAINER (main_area_box), area_data);
   area_data = create_default_main_area();
   gtk_container_add (GTK_CONTAINER (main_area_box), area_data);
}

/* prototype */
int check_dir (GtkCTree *bler, GtkCTreeNode *node, gpointer data);


void populate_site_node (GtkCTreeNode *site_node, struct site_t *current) {
   struct ctree_attachment *file_info_to_add;
   struct site_file_t *current_file;
   gchar *node_label[1];
   GtkCTreeNode *file_im_adding;
   
   for (current_file = current->files; current_file != NULL; current_file = current_file->next ) {
   
      file_info_to_add = malloc (sizeof (struct ctree_attachment));
      file_info_to_add->file_or_site = IS_A_FILE;
      file_info_to_add->sorted_yet = MESSY;
      file_info_to_add->info_struct = (void *) current_file;
      node_label[0] = current_file->rel_local + 1;
      if (current_file->dir) {
	 file_im_adding = gtk_ctree_insert_node (GTK_CTREE (the_tree), 
						 GTK_CTREE_NODE (site_node), NULL,
						 node_label, 3, closed_dir, 
						 dir1_map, open_dir, dir2_map,
						 false, false);
      } else {
	 if (current_file->diff != file_unchanged) {
	    if (current_file->diff == file_changed) {
	       file_im_adding = gtk_ctree_insert_node (GTK_CTREE (the_tree), 
						       GTK_CTREE_NODE (site_node), NULL, node_label, 3,
						       orange_file, orange_file_map, 
						       orange_file, orange_file_map, 
						       FALSE, FALSE);
	    } else {
	       file_im_adding = gtk_ctree_insert_node (GTK_CTREE (the_tree), 
						       GTK_CTREE_NODE (site_node), NULL, node_label, 3,
						       red_file, red_file_map, 
						       red_file, red_file_map, 
						       FALSE, FALSE);
	    }
	 } else { 
	    file_im_adding = gtk_ctree_insert_node (GTK_CTREE (the_tree), 
						    GTK_CTREE_NODE (site_node), NULL, node_label, 3,
						    green_file, green_file_map, 
						    green_file, green_file_map, 
						    FALSE, FALSE);
	 }
      }
      gtk_ctree_node_set_row_data (GTK_CTREE (the_tree), file_im_adding,
				   (gpointer) file_info_to_add);
      file_item = file_im_adding;
      if (current_file->dir) {
	 gtk_ctree_post_recursive (GTK_CTREE (the_tree), site_node,
				  GTK_CTREE_FUNC (check_dir), 
				  (gpointer) file_item);
      }
   }
}

/* This is all a bit hacky, and the growth rate is god awful */

int check_dir (GtkCTree *bler, GtkCTreeNode *node, gpointer data) {
   struct ctree_attachment *folder, *files, *info_to_add;
   GtkCTreeNode *tmp1, *just_moved;
   struct site_file_t *tmpy1, *tmpy2;
   char *folder_name;
   gchar *node_label2[1];
   
   /*folder = malloc (sizeof (struct ctree_attachment));*/
   tmp1 = GTK_CTREE_NODE (data);
   
   files = malloc (sizeof (struct ctree_attachment));
   
   files = (struct ctree_attachment *) gtk_ctree_node_get_row_data (GTK_CTREE (the_tree), GTK_CTREE_NODE (node));
   folder = (struct ctree_attachment *) gtk_ctree_node_get_row_data (GTK_CTREE (the_tree), GTK_CTREE_NODE (tmp1));

   if (files == NULL) {
      return 0;
   } else {
      if (files->sorted_yet == ORGANIZED) 
	return 2;
      if ( (tmpy1 = (struct site_file_t *) files->info_struct) == NULL)
	return 1;
   }
   if (folder == NULL) {
      return 0;
   } else {
      if ( (tmpy2 = (struct site_file_t *) folder->info_struct) == NULL)
	return 1;
   }

   /* ********************************
    * This is just not working when a port is specified in the rcfile.
    * It's madness, sheer madness.... 
    */
   
   /* Okay, so they're directories not folders. */
   folder_name = malloc (BUFSIZ);
   memset (folder_name, 0, BUFSIZ);
   if (tmpy2->rel_local == NULL)
     return 2;
   strcpy (folder_name, tmpy2->rel_local); 
   // The 'tree' is the directory we're testing this file against, so the name
   // of tmpy2 (ie tmpy2->rel_local) is in fact the folder name.
    

   folder_name++;
   /* Directories have a trailing slash, file names don't, so i add one. */
   strcat (folder_name, "/");
   /* debugging */
   //printf ("About to compare folder name (%s) with file's directory (%s).\n",
   //	   folder_name, tmpy1->directory);
   //printf ("Folder's filename is: %s\n", tmpy2->rel_local);
   
   /* 'node' is the current node we're looking at from the post-recursion */
   if ( (tmpy1 != NULL) && (tmpy1->directory != NULL) && (folder_name != NULL) ) {
      if (strcmp (tmpy1->directory, folder_name) == 0) {
	 
	 /*      gtk_ctree_move (GTK_CTREE (the_tree), node, tmp1, NULL);*/
	 node_label2[0] = tmpy1->localname;
	 gtk_ctree_remove_node (GTK_CTREE (the_tree), node);
	 info_to_add = malloc (sizeof (struct ctree_attachment));
	 info_to_add->file_or_site = IS_A_FILE;
	 info_to_add->sorted_yet = ORGANIZED;
	 info_to_add->info_struct = (void *) tmpy1;
	 /* I want to set a different pixmap depending on file status, 
	  * so I do a quick comparison. */
	 if (tmpy1->diff != file_unchanged) {
	    just_moved = gtk_ctree_insert_node (GTK_CTREE (the_tree), 
						GTK_CTREE_NODE (file_item), NULL, node_label2, 3,
						red_file, red_file_map, 
						red_file, red_file_map, 
						FALSE, FALSE);
	 } else { 
	    just_moved = gtk_ctree_insert_node (GTK_CTREE (the_tree), 
						GTK_CTREE_NODE (file_item), NULL, node_label2, 3,
						green_file, green_file_map, 
						green_file, green_file_map, 
						FALSE, FALSE);
	 }
	 gtk_ctree_node_set_row_data (GTK_CTREE (the_tree), GTK_CTREE_NODE (just_moved),
				      (gpointer) info_to_add);
      }
   }
   return 2;
}

GtkWidget *ctree_create_sites (void) {
   struct site_t *current;
   struct ctree_attachment *info_to_add;
   gchar tmp[100];
   gchar *node_label[1];
   
   the_tree = gtk_ctree_new (1, 0); 
   gtk_ctree_set_indent (GTK_CTREE (the_tree), 14);
   gtk_ctree_set_spacing (GTK_CTREE (the_tree), 4);
   gtk_ctree_set_line_style (GTK_CTREE (the_tree), GTK_CTREE_LINES_DOTTED);
   
   gtk_signal_connect (GTK_OBJECT (the_tree), "tree-select-row",
		       GTK_SIGNAL_FUNC (select_ctree_cb), NULL);
   current = malloc (sizeof (struct site_t));

   for (current=all_sites; current != NULL; current = current->next) {

      /* This allocates some memory for each site, and stores the fact that
       * it is a _site_ plus a void pointer to the relavent data.
       * For use in the ctree. Time complexity improvements and all that arse.
       */
      info_to_add = malloc (sizeof (struct ctree_attachment));
      info_to_add->file_or_site = IS_A_SITE;
      info_to_add->info_struct = (void *) current;

      /* Make what's displayed next to the site name an option.
       * E.g. ftp server, or local dir. Remote dir even maybe? */
      
      sprintf (tmp, "%s  (%s)", current->name, current->local_root);
      node_label[0] = tmp;
      site_item = gtk_ctree_insert_node (GTK_CTREE (the_tree), NULL, NULL, node_label,
				     0, NULL, NULL, NULL, NULL, false, false);
      gtk_ctree_node_set_row_data (GTK_CTREE (the_tree), site_item,
				   (gpointer) info_to_add);
      site_readfiles (current);

      populate_site_node (site_item, current);
      gtk_ctree_sort_node (GTK_CTREE (the_tree), GTK_CTREE_NODE (site_item));
   }
   gtk_widget_set_usize (the_tree, 150, -1);
   gtk_widget_show (the_tree);
   gtk_clist_set_column_auto_resize (GTK_CLIST (the_tree), 0, TRUE);
   return the_tree;
}

     
/* Notes:
 * I'll need a site_refresh function which refreshes the info of a given site in the ctree.
 * Otherwise, with a large number of sites/files-per-site, it could take ages just to reload
 * everything after an update.
 * Or will it? Look into this anyway.
 */

/* (DOESN'T) work! */
/* This whole refresh thing works as follows:
 * 
 * Clicking on refresh from the toolbar will call 'status_refresh' which
 * should set the pixmap of each node of the selected site correctly
 * according to changed status & file/dir status.
 * 
 * When selected_site->local_root changes, 'refresh_selected' is called, which
 * rebuilds the file structure of the currently selected site/site node.
 */


/*void set_node_pixmap (GtkCTree *tree, GtkCTreeNode *node_to_colour) {
   struct site_file_t *file_data;
   file_data = (struct site_file_t *) gtk_ctree_node_get_row_data (GTK_CTREE (the_tree),
								   GTK_CTREE_NODE (node_to_colour));
   if (file_data->dir) {
      gtk_ctree_set_node_info (GTK_CTREE (the_tree), 
			      GTK_CTREE_NODE (node_to_colour),
			      NULL, 3, open_dir, dir1_map,
			      closed_dir, dir2_map, false, false);
   } else {
      if (file_data->diff == file_unchanged) {
	 gtk_ctree_set_node_info (GTK_CTREE (the_tree), 
				 GTK_CTREE_NODE (node_to_colour),
				 NULL, 3, green_file, green_file_map,
				 green_file, green_file_map, false, false);
      } else {
	 gtk_ctree_set_node_info (GTK_CTREE (the_tree), 
				 GTK_CTREE_NODE (node_to_colour),
				 NULL, 3, red_file, red_file_map,
				 red_file, red_file_map, false, false);
      }
   }
}*/
     
/*void status_refresh (GtkCTree *a_tree, GtkCTreeNode *node_to_wibble_over) {
   gtk_ctree_post_recursive (GTK_CTREE (the_tree), 
			     GTK_CTREE_NODE (node_to_wibble_over),
			     GTK_CTREE_FUNC (set_node_pixmap),
			     NULL);
}*/

/* Dammit. This *really* isn't working.... :\  */

void refresh_site_node (GtkCTreeNode *node_to_refresh, struct site_t *site_to_refresh) {

   /* This sucks... We have to remove each and *every* child node one by one */
   if (! node_to_refresh) {
      fe_status ("You must select a site to refresh first!");
      return;
   } else if (! site_to_refresh) {
      fe_status ("Somehow site_to_refresh is NULL. Oh deary me.");
      return;
   }
//   printf ("Using %s as site to refresh.\n About to destroy...\n", site_to_refresh->name);   printf ("Using %s as site to refresh.\n About to destroy...\n", site_to_refresh->name);   printf ("Using %s as site to refresh.\n About to destroy...\n", site_to_refresh->name);   printf ("Using %s as site to refresh.\n About to destroy...\n", site_to_refresh->name);
   gtk_ctree_post_recursive (GTK_CTREE (the_tree),
			     GTK_CTREE_NODE (node_to_refresh),
			     GTK_CTREE_FUNC (gtk_ctree_remove_node),
			     NULL);
   /* Now all the nodes are gone, destroy the site's file list. */
   printf ("destroying files...\n");
/*   site_destroy (site_to_refresh);*/
   /* Now re-read the local directory info */
   printf ("reading file info...\n");
/*   site_readfiles (site_to_refresh);*/
   printf ("Now populating...\n");
   /* And re-populate.... */
   populate_site_node (GTK_CTREE_NODE (node_to_refresh), site_to_refresh);
}

void refresh_selected (GtkWidget *button, gpointer data) {
/*   status_refresh (the_tree, site_item);*/
   refresh_site_node (site_item, selected_site);
}

/* I should probably make a fe_gnome_network_transfer.c file and move this and
 * all the update/resync stuff in there... 
 */

/* Should this be global? Would be nicer to function-ify it. */
void make_error_window (void) {
   GtkWidget *vbox, *label, *cancel;
   GtkWidget *sc_win;
   gchar *error_titles[2];
   
   error_log_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title (GTK_WINDOW (error_log_window), "Errors that were encountered");
   gtk_signal_connect_object (GTK_OBJECT (error_log_window), "delete_event",
			      GTK_SIGNAL_FUNC (gtk_widget_hide),
			      GTK_OBJECT (error_log_window));
   gtk_container_set_border_width (GTK_CONTAINER (error_log_window), 5);
   
   vbox = gtk_vbox_new (FALSE, 4);
   gtk_widget_show (vbox);
   
   label = gtk_label_new ("There were errors with the following files/directories:");
   gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 4);
   gtk_widget_show (label);
   
   error_titles[0] = "File/Directory";
   error_titles[1] = "Error that occured";
   error_log_list = gtk_clist_new_with_titles (2, error_titles);
   gtk_clist_set_column_auto_resize (GTK_CLIST (error_log_list), 0, TRUE);
   gtk_clist_set_column_auto_resize (GTK_CLIST (error_log_list), 1, TRUE);
   
   sc_win = gtk_scrolled_window_new (NULL, NULL);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sc_win),
				   GTK_POLICY_AUTOMATIC,
				   GTK_POLICY_AUTOMATIC);
   gtk_container_add (GTK_CONTAINER (sc_win), error_log_list);
   gtk_widget_show (sc_win);
   gtk_box_pack_start (GTK_BOX (vbox), sc_win, TRUE, TRUE, 4);
   gtk_widget_show (error_log_list);
   
   cancel = gtk_button_new_with_label ("Close");
   gtk_signal_connect_object (GTK_OBJECT (cancel), "clicked",
			      GTK_SIGNAL_FUNC (gtk_widget_hide), 
			      GTK_OBJECT (error_log_window));
   gtk_box_pack_start (GTK_BOX (vbox), cancel, FALSE, FALSE, 4);
   gtk_widget_show (cancel);
   gtk_container_add (GTK_CONTAINER (error_log_window), vbox);
   /* We're not showing the win until the user hits "Error Log" remember */
}
   
